MODULE YOMTRSL

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!   -----------------------------------------------------------------

!*   Buffer for trajectory array at time t-dt
!    (used for tangent-linear and adjoint of semi-Lagrangian)

!    NLENGTSLB                    : length of buffer for 3D fields
!    NTRSLTYPE                    : trajectory storage method -
!                                   =0 no storage (only works for LELTRA=T)
!                                   =1 minimum storage
!                                   =2 more storage, less computation
!       ** N.B. Only NTRSLTYPE=2 is supported in the 3-d model **
!    NPCKSLTRAJ                   : packing factor (<=2) for SL trajectory
!    TRAJSL(0:NSTOP,NLENGTSLB)    : buffer for 3D fields
!    NSTAGTSLB(NDGSAG:NDGENG)     : start adresses for packets within buffer
!                                   for 3D fields

INTEGER(KIND=JPIM) :: NLENGTSLB
INTEGER(KIND=JPIM) :: NTRSLTYPE
INTEGER(KIND=JPIM) :: NPCKSLTRAJ

REAL(KIND=JPRB),ALLOCATABLE:: TRAJSL(:,:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NSTAGTSLB(:)

!   ----------------------------------------------------------------
END MODULE YOMTRSL
